//
//  AppDelegate.m
//  CHNYC PlugIn Demo
//
//  Created by Jonathan Nathan on 10/11/11.
//  Copyright 2011 JNSoftware LLC. All rights reserved.
//

#import "AppDelegate.h"
#import <CHNYCPlugInDemo/CHNYCPlugInDemo.h>

static NSUserDefaults *standardUserDefaults = nil;

@implementation AppDelegate

@synthesize window, arrayController;

+ (void)initialize {
	static BOOL isInitialzed = NO;
	if (!isInitialzed) {
		standardUserDefaults = [NSUserDefaults standardUserDefaults];
		NSDictionary *appDefaults = [NSDictionary dictionaryWithObjectsAndKeys:
									 [NSNumber numberWithInteger:0], @"lastSelectionIndex", 
									 nil];
		[standardUserDefaults registerDefaults:appDefaults];
		[standardUserDefaults synchronize];
		isInitialzed = YES;
	}
}

- (void)applicationDidFinishLaunching:(NSNotification *)notification {
	[CHNYCPlugIn loadPlugIns];
#if DEBUG
	NSLog(@"loaded plugins: %@", [[[CHNYCPlugIn loadedPlugIns] valueForKey:@"identifier"] componentsJoinedByString:@", "]);
#endif
	[arrayController setContent:[CHNYCPlugIn loadedPlugIns]];
	[arrayController setSortDescriptors:[NSArray arrayWithObjects:[[[NSSortDescriptor alloc] initWithKey:@"displayName" ascending:YES] autorelease], nil]];
	[arrayController rearrangeObjects];
	[arrayController setSelectionIndex:[standardUserDefaults integerForKey:@"lastSelectionIndex"]];
	if (![standardUserDefaults objectForKey:[NSString stringWithFormat:@"NSWindow Frame %@", [window frameAutosaveName]]]) [window center];
	[window makeKeyAndOrderFront:nil];
}

- (void)applicationWillTerminate:(NSNotification *)notification {
	[standardUserDefaults setInteger:[arrayController selectionIndex] forKey:@"lastSelectionIndex"];
	[standardUserDefaults synchronize];
}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)application {
	return YES;
}

- (IBAction)sayHello:(id)sender {
	CHNYCPlugIn *plugIn = (CHNYCPlugIn *)[[arrayController selectedObjects] lastObject];
	if (plugIn) [plugIn sayHello];
}

@end
